/*
 Si definisca un metodo stand-alone per il calcolo del fattoriale che,
 applicato ad un intero negativo, solleva un'eccezione di una classe
 "InvalidArgException" in grado di ricordare il parametro invalido.
 1) Si fornisca la definizione del metodo e della classe invalidException 
    e se ne verifichi la corretta compilazione;
 2) Si mostri un caso di uso che cattura l'eccezione e stampa il valore
    invalido con cui è stata invocata l'applicazione e se ne verifichi 
    l'attesa computazione.
 */

import java.io.*;
import java.util.*;

class invalidArgException extends Exception {//punto 1
    String name;
    Object arg;
    invalidArgException(String s, Object v){
        name = s;
        arg = v;
    }
}
class Fact {//punto 1
    static int fact(int n) throws invalidArgException{
        if (n<0) throw new invalidArgException("fact",n);
        if (n==0) return 1;
        return n*fact(n-1);
    }
}

class Main{//punto 2: caso di uso
    public static void main(String[] args) {
        Scanner in = new Scanner(System.in);
        /* InputMismatchException */
        int k = 0;
        while(true){
            try{
                k = in.nextInt();
                System.out.println("fact("+k+")="+Fact.fact(k));
            }
            catch(InputMismatchException e){return;}
            catch(invalidArgException e){
                System.out.println("Exception in "+e.name+": "+((Integer)(e.arg)));
            }
        }
    }
}








