/*
 Un esempio di uso di interfaccia
 */

import java.io.*;
import java.util.*;

interface sortable{
	public boolean ord(sortable s);
}

class sortedName implements sortable{
	private String name;
	public sortedName(String n){
		name = n;
	}
	public boolean ord(sortable s){
		return ((sortedName)s).name.startsWith(this.name);
    }
}


/*
Esercizi a completamento.
 
Esercizio 1)
Compilare e mostrare un caso di uso dela classe sortedName
 
Esercizio 2)
Il metodo ord, in sortedName, è riflessivo, e transitivo. Estenderlo in un preordine totale
in modo tale che per ogni u,v, u.ord(v) oppure v.ord(u). 
Per semplicità si rimuova il modificatore "private" dalla dichiarazioe di name. Quindi, si 
estenda la classe ottenuta in una nuova classe che chiameremo "totalSortedName" e che comp-
pleta l'ordinamento definito da ord con quello lessicografico.
Si completi l'eserizio compilando il codice completato di un caso di uso della nuova classe.
*/